src/AppBundle/Entity/Votable.php
<?php

namespace Raddit\AppBundle\Entity;

use Doctrine\Common\Collections\Collection;
use Doctrine\Common\Collections\Criteria;
use Doctrine\Common\Collections\Selectable;

abstract class Votable {
    /**
     * @return Vote[]|Collection|Selectable
     */
    abstract public function getVotes();

    /**
     * @return Vote
     */
    abstract public function createVote();

    /**
     * @return int
     */
    public function getUpvotes() {
        $criteria = Criteria::create();
        $criteria->where(Criteria::expr()->eq('upvote', true));

        return count($this->getVotes()->matching($criteria));
    }

    /**
     * @return int
     */
    public function getDownvotes() {
        $criteria = Criteria::create();
        $criteria->where(Criteria::expr()->eq('upvote', false));

        return count($this->getVotes()->matching($criteria));
    }

    /**
     * @return int
     */
    public function getNetScore() {
        return $this->getUpvotes() - $this->getDownvotes();
    }

    /**
     * @param User $user
     *
     * @return Vote|null
     */
    public function getUserVote(User $user) {
        $criteria = Criteria::create();
        $criteria->where(Criteria::expr()->eq('user', $user));

        return $this->getVotes()->matching($criteria)->first();
    }

    /**
     * @param Votable $a
     * @param Votable $b
     *
     * @return int
     */
    final public static function descendingNetScoreCmp(self $a, self $b) {
        return $b->getNetScore() <=> $a->getNetScore();
    }
}

src/AppBundle/Resources/views/macros/comments.html.twig
{% macro comment(comment, recurse) %}
  {{- block('comment') -}}
{% endmacro %}

{% macro comment_form(submission, comment) %}
  {% if is_granted('ROLE_USER') %}
    {{ render(controller('RadditAppBundle:Comment:commentForm', {
      forumName: submission.forum.name,
      submissionId: submission.id,
      commentId: comment.id|default(null)
    })) }}
  {% else %}
    <p class="must-log-in">{{ 'comments.not_logged_in'|trans({
        '%login_link%': '<a href="%s">%s</a>'|format(
          path('raddit_app_login'),
          'comments.not_logged_in_login_link_label'|trans
        ),
        '%register_link%': '<a href="%s">%s</a>'|format(
          path('raddit_app_registration'),
          'comments.not_logged_in_register_link_label'|trans
        ),
      })|raw }}</p>
  {% endif %}
{% endmacro %}

{%- block comment -%}
  {%- from '@RadditApp/macros/votes.html.twig' import vote -%}
  <article class="comment comment-{{ level|default(0) ? 'level-'~level : 'top-level' }} {{ comment.softDeleted ? 'comment-soft-deleted' }}" id="comment_{{ comment.id }}">
    <div class="comment-row">
      <div class="comment-vote">
        {{ vote(comment, path('raddit_app_comment_vote', {id: comment.id})) }}
      </div>

      <div class="comment-inner">
        <h1 class="comment-info">{{ 'comments.info'|trans({
            '%user%': block('comment_info_user'),
            '%timestamp%': block('comment_info_timestamp'),
          })|raw }}</h1>

        <div class="comment-body">
          {{ comment.body|cached_markdown|raw }}
        </div>

        <nav class="comment-nav">
          <ul>{{ block('comment_nav') }}</ul>
        </nav>
      </div>
    </div>

    {% if recurse ?? true and comment.children|length > 0 %}
      <div class="comment-replies">
        {%- for reply in comment.children -%}
          {%- with { comment: reply, level: level|default(0) + 1} only -%}
            {{- block('comment') -}}
          {%- endwith -%}
        {%- endfor -%}
      </div>
    {% endif %}
  </article>
{%- endblock -%}

{%- block comment_info_user -%}
  {%- if not comment.softDeleted -%}
    <a href="{{ path('raddit_app_user', {username: comment.user.username}) }}" class="comment-user">
      {{- comment.user.username -}}
    </a>
  {%- else -%}
    {{- 'comments.author_deleted'|trans -}}
  {%- endif -%}
{%- endblock -%}

{%- block comment_info_timestamp -%}
  {%- set date = comment.timestamp|localizeddate('long', 'short') -%}
  <time datetime="{{ comment.timestamp|date('c') }}" title="{{ date }}" class="comment-timestamp relative-time">
    {{- 'comments.info_at_timestamp'|trans({'%timestamp%': date}) -}}
  </time>
{%- endblock -%}

{%- block comment_nav -%}
  {{- block('comment_nav_permalink') -}}
  {{- block('comment_nav_parent') -}}
  {{- block('comment_nav_delete') -}}
  {{- block('comment_nav_edit') }}
{%- endblock -%}

{%- block comment_nav_permalink -%}
  {%- spaceless -%}
    <li class="comment-nav-permalink">
      <a href="{{ path('raddit_app_comment', {
        forum_name: comment.submission.forum.name,
        submission_id: comment.submission.id,
        comment_id: comment.id
      }) }}">{{ 'comments.permalink'|trans }}</a>
    </li>
  {%- endspaceless -%}
{%- endblock -%}

{%- block comment_nav_parent -%}
  {%- spaceless -%}
    {%- if comment.parent -%}
      <li class="comment-nav-parent">
        <a href="{{ path('raddit_app_comment', {
          forum_name: comment.submission.forum.name,
          submission_id: comment.submission.id,
          comment_id: comment.parent.id
        }) }}">{{ 'comments.parent'|trans }}</a>
      </li>
    {%- endif -%}
  {%- endspaceless -%}
{%- endblock -%}

{# Forms are used here because we need to support JS-less browsing and because
 # GET requests should never mutate the state of the application. #}
{%- block comment_nav_delete -%}
  {%- if comment.children|length > 0 and is_granted('delete_thread', comment) -%}
    {%- set delete_thread_label = 'comments.delete_thread' -%}
    {{- block('comment_nav_delete_thread') -}}
    {{- block('comment_nav_delete_softdelete') -}}
  {%- elseif is_granted('delete', comment) -%}
    {%- set delete_thread_label = 'comments.delete' -%}
    {{- block('comment_nav_delete_thread') -}}
  {%- endif -%}
{%- endblock -%}

{%- block comment_nav_delete_softdelete -%}
  {%- spaceless -%}
    <li class="comment-nav-softdelete">
      <form action="{{ path('raddit_app_softdelete_comment', {id: comment.id}) }}" method="POST">
        <input type="hidden" name="token" value="{{ csrf_token('softdelete_comment') }}">
        <button type="submit">{{ 'comments.delete'|trans }}</button>
      </form>
    </li>
  {%- endspaceless -%}
{%- endblock -%}

{%- block comment_nav_delete_thread -%}
  {%- spaceless -%}
    <li class="comment-nav-delete-thread">
      <form action="{{ path('raddit_app_delete_comment', {id: comment.id}) }}" method="POST">
        <input type="hidden" name="token" value="{{ csrf_token('delete_comment') }}">
        <button type="submit">{{ delete_thread_label|trans }}</button>
      </form>
    </li>
  {%- endspaceless -%}
{%- endblock -%}

{%- block comment_nav_edit -%}
  {%- spaceless -%}
    {%- if is_granted('edit', comment) -%}
      <li class="comment-nav-edit">
        <a href="{{ path('raddit_app_edit_comment', {
          forum_name: comment.submission.forum.name,
          submission_id: comment.submission.id,
          comment_id: comment.id,
        }) }}">{{ 'comments.edit'|trans }}</a>
      </li>
    {%- endif -%}
  {%- endspaceless -%}
{%- endblock -%}

src/AppBundle/Resources/views/macros/submissions.html.twig
{%- macro submission(submission, options) -%}
  {%- set options = {
    show_body: false,
    show_forum_name: true,
  }|merge(options|default({})) -%}

  {{- block('submission') -}}
{%- endmacro -%}

{%- macro submission_sort(current) -%}
  {%- spaceless -%}
  <nav class="submission-sort">
    <ul>
      {%- for type in ['hot', 'new', 'top', 'controversial'] -%}
        <li>
          <a href="{{ path(
              app.request.attributes.get('_route'),
              app.request.attributes.get('_route_params')|default([])|merge({sortBy: type}))
          }}" class="{{ type == current ? 'active' }}">
            {{- ('submissions.sort_by_'~type)|trans -}}
          </a>
        </li>
      {%- endfor -%}
    </ul>
  </nav>
  {%- endspaceless -%}
{%- endmacro -%}

{%- block submission_info_submitter -%}
  <a href="{{ path('raddit_app_user', {username: submission.user.username}) }}" class="submission-submitter">
    {{- submission.user.username -}}
  </a>
{%- endblock -%}

{%- block submission_info_timestamp -%}
  {%- set date = submission.timestamp|localizeddate('long', 'short') -%}
  <time datetime="{{ submission.timestamp|date('c') }}" title="{{ date }}" class="submission-timestamp relative-time">
    {{- 'submissions.info_at_timestamp'|trans({'%timestamp%': date}) -}}
  </time>
{%- endblock -%}

{%- block submission_info_forum_name -%}
  <a href="{{ path('raddit_app_forum', {forum_name: submission.forum.name}) }}" class="submission-forum">
    {{- submission.forum.name -}}
  </a>
{%- endblock -%}

{%- block submission -%}
  {%- from '@RadditApp/macros/votes.html.twig' import vote -%}
  <article class="submission {{ submission.url ? 'submission-has-url' }} {{ submission.body is not null ? 'submission-has-body' }} {{ not options.show_body ? 'submission-body-hidden' }}">
    <div class="submission-row">
      <div class="submission-vote">
        {{- vote(submission, path('raddit_app_submission_vote', {id: submission.id})) -}}
      </div>

      <div class="submission-inner">
        <header class="submission-header">
          {% spaceless %}
            <h1 class="submission-title">
              <a href="{{ block('submission_url') }}" class="submission-link">
                {{- submission.title -}}
              </a>
            </h1>
          {% endspaceless %}

          <p class="submission-info">
            {%- if options.show_forum_name -%}
              {{ 'submissions.info_with_forum_name'|trans({
                '%submitter%': block('submission_info_submitter'),
                '%timestamp%': block('submission_info_timestamp'),
                '%forum%': block('submission_info_forum_name'),
              })|raw }}
            {%- else -%}
              {{ 'submissions.info_without_forum_name'|trans({
                '%submitter%': block('submission_info_submitter'),
                '%timestamp%': block('submission_info_timestamp'),
              })|raw }}
            {%- endif -%}
          </p>
        </header>

        {%- if options.show_body -%}
          {% if submission.url %}
            <div class="submission-media">{{ block('submission_media') }}</div>
          {% endif %}

          {% if submission.body is not null %}
            <div class="submission-body">{{ submission.body|cached_markdown|raw }}</div>
          {% endif %}
        {%- endif -%}

        {%- spaceless -%}
          <nav class="submission-nav">
            <ul>
              <li>
                <a href="{{ path('raddit_app_comments', {forum_name: submission.forum.name, submission_id: submission.id}) }}">
                  {{- 'submissions.comments'|transchoice(submission.comments|length) -}}
                </a>
              </li>
              {%- if is_granted('edit', submission) -%}
                <li>
                  <a href="{{ path('raddit_app_edit_submission', {forum_name: submission.forum.name, submission_id: submission.id}) }}">
                    {{- 'submissions.edit'|trans -}}
                  </a>
                </li>
              {%- endif -%}
            </ul>
          </nav>
        {%- endspaceless -%}
      </div>
    </div>
  </article>
{% endblock %}

{%- block submission_url -%}
  {%- if submission.url -%}
    {{- submission.url -}}
  {%- else -%}
    {{- path('raddit_app_comments', {forum_name: submission.forum.name, submission_id: submission.id}) -}}
  {%- endif -%}
{%- endblock -%}

{%- block submission_media -%}
  {# TODO #}
{%- endblock -%}

src/AppBundle/Resources/views/macros/votes.html.twig
{%- macro vote(entity, vote_path) -%}
  {{- block('vote') -}}
{%- endmacro -%}

{%- block vote -%}
  {%- set user_vote = is_granted('ROLE_USER') ? entity.userVote(app.user) : null -%}
  {%- spaceless -%}
    <form action="{{ vote_path }}" method="post" class="vote {{ block('vote_class') }}" data-score="{{ entity.netScore }}">
      <input type="hidden" name="token" value="{{ csrf_token('vote') }}">

      <button type="submit" name="choice" value="{{ block('vote_choice_up') }}"
              class="vote-button vote-up" title="{{ block('vote_up_label') }}">
        {#- http://mts.io/2015/04/21/unicode-symbol-render-text-emoji/ -#}
        <span class="inner" aria-hidden="true">&#x2B06;&#xFE0E;</span>
      </button>

      <span class="vote-score">{{ entity.netScore }}</span>

      <button type="submit" name="choice" value="{{ block('vote_choice_down') }}"
              class="vote-button vote-down" title="{{ block('vote_down_label') }}">
        <span class="inner" aria-hidden="true">&#x2B07;&#xFE0E;</span>
      </button>
    </form>
  {%- endspaceless -%}
{%- endblock -%}

{%- block vote_class -%}
  {%- if not user_vote -%}
    {#- nothing -#}
  {%- elseif user_vote.upvote -%}
    vote-user-upvoted
  {%- else -%}
    vote-user-downvoted
  {%- endif -%}
{%- endblock -%}

{%- block vote_choice_up -%}
  {{- user_vote and user_vote.upvote ? 0 : 1 -}}
{%- endblock -%}

{%- block vote_choice_down -%}
  {{- user_vote and not user_vote.upvote ? 0 : -1 -}}
{%- endblock -%}

{%- block vote_up_label -%}
  {{- (user_vote and user_vote.upvote ? 'votes.retract_upvote' : 'votes.upvote')|trans -}}
{%- endblock -%}

{%- block vote_down_label -%}
  {{- (user_vote and not user_vote.upvote ? 'votes.retract_downvote' : 'votes.downvote')|trans -}}
{%- endblock -%}